﻿// --------------------------------
// <copyright file="CompileEngineTest.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Tronsoft.Actucal.CalculationEngineCreator.Test
{   
    /// <summary>
    ///This is a test class for CompileEngineTest and is intended
    ///to contain all CompileEngineTest Unit Tests
    ///</summary>
    [TestClass()]
    public class CompileEngineTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Run
        ///</summary>
        [TestMethod()]
        [DeploymentItem("CalculationEngineCreator.dll")]
        public void Should_Create_An_Assembly()
        {
            CalculationParameterCollection collection = new CalculationParameterCollection();
            collection.Add(new CalculationParameter<int>("p1", 1));

            CalculationModel model = new CalculationModel(collection);

            Formula formula = new Formula("Test", "return 1 + p1");
            model.Calculations.Add(new Calculation(formula));

            CompileEngine engine = new CompileEngine(model);
            Assert.IsNotNull(engine.CreateAssembly());
        }

        /// <summary>
        ///A test for CompileEngine Constructor
        ///</summary>
        [TestMethod()]
        [DeploymentItem("CalculationEngineCreator.dll")]
        public void CompileEngineConstructorTest()
        {
            //CalculationModel_Accessor model = null; // TODO: Initialize to an appropriate value
            //CodeDomProvider provider = null; // TODO: Initialize to an appropriate value
            //CompileEngine_Accessor target = new CompileEngine_Accessor(model, provider);
            //Assert.Inconclusive("TODO: Implement code to verify target");
        }
    }
}
