﻿// --------------------------------
// <copyright file="Calculation.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;

namespace Tronsoft.Actucal.CalculationEngineCreator
{
    public class Calculation
    {
        #region Private\Protected Fields

        private readonly Formula formula;

        #endregion

        #region Properties

        public Formula Formula
        {
            get { return formula; }
        }

        public string Name
        {
            get { return formula.Name; }
        }

        #endregion

        #region ctors

        public Calculation(Formula formula)
        {
            if (formula == null) throw new ArgumentNullException("formula");

            this.formula = formula;
        }

        #endregion
    }
}