﻿// --------------------------------
// <copyright file="CalculationException.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;
using System.Runtime.Serialization;

namespace Tronsoft.Actucal.CalculationEngineCreator
{
    /// <summary>
    /// This class encapsulates an exception from the calculation
    /// generation engine.
    /// </summary>
    [Serializable]
    public class CalculationException : Exception
    {
        //
        // For guidelines regarding the creation of new exception types, see
        //    http://msdn.microsoft.com/library/default.asp?url=/library/en-us/cpgenref/html/cpconerrorraisinghandlingguidelines.asp
        // and
        //    http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dncscol/html/csharp07192001.asp
        //

        public CalculationException()
        {
        }

        public CalculationException(string message) : base(message)
        {
        }

        public CalculationException(string message, Exception inner) : base(message, inner)
        {
        }

        protected CalculationException(
            SerializationInfo info,
            StreamingContext context)
            : base(info, context)
        {
        }
    }
}