﻿// --------------------------------
// <copyright file="CalculationParameterCollection.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

namespace Tronsoft.Actucal.CalculationEngineCreator
{
    public class CalculationParameterCollection : UniqueElementList<ICalculationParameter> 
    {
        public ICalculationParameter this[string key]
        {
            get
            {
                return this[FindIndex(
                                delegate(ICalculationParameter param) { return param.Name == key; }
                                )];
            }
            set
            {
                this[FindIndex(
                         delegate(ICalculationParameter param) { return param.Name == key; }
                         )] = value;
            }
        }
    }
}