// --------------------------------
// <copyright file="ConstantCollection.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;

namespace Tronsoft.Actucal.CalculationEngineCreator
{
    [Serializable]
    public class ConstantCollection : UniqueElementList<INameValueCombination>
    {
        public INameValueCombination this[string index]
        {
            get { return this.Find(delegate(INameValueCombination constant) { return (constant.Name.Equals(index)); }); }
            set
            {
                if (null == value)
                    throw new ArgumentNullException("value");

                INameValueCombination constant = this.Find(delegate(INameValueCombination constantParam) { return (constantParam.Name.Equals(index)); });
                if (null != constant)
                {
                    constant.Value = value;
                }
            }
        }
    }
}