﻿// --------------------------------
// <copyright file="MethodDefinition.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;

namespace Tronsoft.Actucal.CalculationEngineCreator
{
    public class MethodDefinition
    {
        private readonly string body;
        private readonly string name;
        private readonly MethodSignature signature;

        public MethodDefinition(string name, MethodSignature signature, string body)
        {
            if (string.IsNullOrEmpty(name)) 
                throw new ArgumentNullException("name");
            if (name.Contains(" "))
                throw new ArgumentException("A name cannot contains spaces.", "name");
            if (signature == null) 
                throw new ArgumentNullException("signature");
            if (string.IsNullOrEmpty(body)) 
                throw new ArgumentNullException("body");

            this.name = name;
            this.signature = signature;
            this.body = body;
        }

        public MethodSignature Signature
        {
            get { return signature; }
        }

        public string Body
        {
            get { return body; }
        }

        public string Name
        {
            get { return name; }
        }
    }
}