﻿// --------------------------------
// <copyright file="MethodSignature.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;
using System.CodeDom;

namespace Tronsoft.Actucal.CalculationEngineCreator
{
    public class MethodSignature
    {
        private readonly MethodParameterCollection parameters = new MethodParameterCollection();
        private Type returnValue = typeof (void);

        public MethodParameterCollection Parameters
        {
            get { return parameters; }
        }

        public Type ReturnValue
        {
            get { return returnValue; }
            set { returnValue = value; }
        }

        public MethodParameter AddParameter(string name, Type type)
        {
            return AddParameter(name, FieldDirection.In, type);
        }

        public MethodParameter AddParameter(string name, FieldDirection direction, Type type)
        {
            if (string.IsNullOrEmpty(name))
                throw new ArgumentNullException("name");
            if (name.Contains(" "))
                throw new ArgumentException("A name cannot contains spaces.", "name");
            if (type == null) 
                throw new ArgumentNullException("type");

            MethodParameter parameter = new MethodParameter(name, direction, type);
            parameters.Add(parameter);

            return parameter;
        }
    }
}