// --------------------------------
// <copyright file="TableColumn.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;

namespace Tronsoft.Actucal.Tables
{
    public class TableColumn
    {
        private readonly string columnName;
        private readonly Type dataType;

        internal TableColumn(string name, Type dataType)
        {
            if (string.IsNullOrEmpty(name)) throw new ArgumentNullException("name");
            if (dataType == null) throw new ArgumentNullException("dataType");

            columnName = name;
            this.dataType = dataType;
        }

        public string ColumnName
        {
            get { return columnName; }
        }

        public Type DataType
        {
            get { return dataType; }
        }
    }
}