// --------------------------------
// <copyright file="TableRow.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;
using System.Data;

namespace Tronsoft.Actucal.Tables
{
    public class TableRow
    {
        private readonly DataRow row;

        internal TableRow(DataRow row)
        {
            if (row == null) throw new ArgumentNullException("row");

            this.row = row;
        }

        public object[] RowData
        {
            get { return row.ItemArray; }
        }

        public object this[int columnIndex]
        {
            get { return row[columnIndex]; }
        }

        public object this[string columnName]
        {
            get { return row[columnName]; }
        }
    }
}