﻿// --------------------------------
// <copyright file="CalculationParameterTest.cs" company="TRONSoft">
//     Copyright (c) TRONSoft.
// </copyright>
// <license>
//   This source code is subject to terms and conditions of the Microsoft
//   Public License. A copy of the license can be found in the License.html
//   file at the root of this distribution. If you cannot locate the
//   Microsoft Public License, please send an email to dlr@microsoft.com.
//   By using this source code in any fashion, you are agreeing to be bound 
//   by the terms of the Microsoft Public License. You must not remove this
//   notice, or any other, from this software.
// </license>
// <author>Tron</author>
// ---------------------------------

using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Tronsoft.Actucal.CalculationEngineCreator.Test
{  
    /// <summary>
    ///This is a test class for CalculationParameterTest and is intended
    ///to contain all CalculationParameterTest Unit Tests
    ///</summary>
    [TestClass()]
    public class CalculationParameterTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        ///A test for CalculationParameter
        ///</summary>
        [TestMethod()]
        [DeploymentItem("CalculationEngineCreator.dll")]
        public void CalculationParameter_Should_Have_The_Assigned_Value()
        {
            CalculationParameter<int> paramInt = new CalculationParameter<int>("p1", 1);

            Assert.IsTrue(typeof(int) == paramInt.Type);
            Assert.AreEqual(paramInt.Value, 1);
        }

        /// <summary>
        ///A test for CalculationParameter
        ///</summary>
        [TestMethod()]
        [DeploymentItem("CalculationEngineCreator.dll")]
        public void CalculationParameter_Should_Have_The_Assigned_Name()
        {
            CalculationParameter<int> paramInt = new CalculationParameter<int>("p1", 1);

            Assert.IsTrue(typeof(int) == paramInt.Type);
            Assert.AreEqual(paramInt.Name, "p1");
        }

        [TestMethod()]
        [ExpectedException(typeof(ArgumentException))]
        public void CalculationParameter_A_Name_Cannot_Contain_Spaces()
        {
            CalculationParameter<int> paramInt = new CalculationParameter<int>("p 1", 1);
        }

        [TestMethod()]
        public void CalculationParameter_Strings_Must_Be_Acceptable()
        {
            CalculationParameter<string> param = new CalculationParameter<string>("foo", "bar");

            Assert.AreEqual("bar", param.Value);
        }
    }
}
